package com.bocloud.cos.entity;

import com.bocloud.cos.entity.internel.CloudVendor;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 商品SKU
 *
 * @author Administrator
 */
@Table("service_address")
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
public class ServiceAddress extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;

    /**
     * 联系人
     */
    @Column
    private String contactName;

    /**
     * 联系电话
     */
    @Column
    private String contactPhone;

    /**
     *  邮箱
     */
    @Column
    private String contactEmail;

    /**
     * 服务商类型
     */
    @Column
    private String type;


    /**
     * 所属组织
     */
    @Column
    private Long departId;

    /**
     * 所属组织
     */
    @Column
    private String departIds;

    /**
     * 编码
     */
    @Column
    private String code;

    /**
     * 地市
     */
    @Column
    private String city;

    /**
     * 创建人类型
     */
    @Column
    private String creatorType;

    @IgnoreAll
    private List<Long> cloudVendorIds;

    @IgnoreAll
    private List<CloudVendor> cloudVendors;

    @IgnoreAll
    private String creator;

    @IgnoreAll
    private String departName;

    @IgnoreAll
    private String typeName;

    @IgnoreAll
    private String cityName;
}
