package com.bocloud.cos.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 服务类型
 *
 * @author Administrator
 */
@Data
@Table("service_category")
@EqualsAndHashCode(callSuper = true)
@AllArgsConstructor
@NoArgsConstructor
public class ServiceCategory extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 服务id
     */
    @Column("service_id")
    private Long serviceId;
    /**
     * 服务名称
     */
    @IgnoreAll
    private String serviceName;
    /**
     * 服务目录id
     */
    @IgnoreAll
    private Long catalogId;
    /**
     * 服务目录名称
     */
    @IgnoreAll
    private String catalogName;
    /**
     * 服务类型编码
     */
    @Column("code")
    private String code;
    /**
     * 是否内置
     */
    @Column("is_reserved")
    private Boolean reserved;
    @Column("sn")
    private String sn;
}
