package com.bocloud.cos.entity;

import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import com.bocloud.cos.enums.ApplyCategory;
import com.megatron.entity.annotations.*;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author tyl
 * @since 2021/5/10 14:42
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Table("service_flow_config")
@NoArgsConstructor
@AllArgsConstructor
public class ServiceFlowConfig extends Generic {
    @PK(PKStrategy.AUTO)
    private Long id;
    @Column("service_id")
    private Long serviceId;
    @IgnoreAll
    private String serviceName;
    @Column("flow_id")
    private Long flowId;
    @IgnoreAll
    private String flowName;
    @IgnoreUpdate
    @Column("gmt_create")
    @JsonSerialize(
            using = DateSerializer.class
    )
    @JsonDeserialize(
            using = DateDeserializer.class
    )
    @DateTimeFormat(
            pattern = "yyyy-MM-dd HH:mm:ss"
    )
    private Date gmtCreate;
    @Column("creator_id")
    private Long creatorId;
    @Column("category")
    private ApplyCategory category;


    public ServiceFlowConfig(Long serviceId, Long flowId, Date gmtCreate, Long creatorId, ApplyCategory category) {
        this.serviceId = serviceId;
        this.flowId = flowId;
        this.gmtCreate = gmtCreate;
        this.creatorId = creatorId;
        this.category = category;
    }
}
