package com.bocloud.cos.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;

/**
 * 服务SLA
 *
 * @author Administrator
 */
@Table("service_sla")
@Data
public class ServiceSla extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("content")
    private String content;
    @Column("service_id")
    private Long serviceId;
    @IgnoreAll
    private String serviceName;
    @IgnoreAll
    private Long catalogId;
    @IgnoreAll
    private String catalogName;
    @IgnoreAll
    private String creatorName;

    public enum Status {
        /**
         * 启用
         */
        enable,
        /**
         * 禁用
         */
        disable
    }

}
