package com.bocloud.cos.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 服务授权
 *
 * @author Administrator
 */
@Table("service_tenant")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class ServiceTenant extends Generic {

    /**
     * id
     */
    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 服务Id
     */
    @Column("service_id")
    private Long serviceId;
    /**
     * 服务编码
     */
    @IgnoreAll
    private String serviceCode;
    /**
     * 租户id
     */
    @Column("tenant_id")
    private Long tenantId;

    public ServiceTenant(Long serviceId, Long tenantId) {
        super();
        this.serviceId = serviceId;
        this.tenantId = tenantId;
    }

}
