package com.bocloud.cos.entity.assess;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 考核采集对象明细
 *
 * @author lym
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("assess_collection_object_detail")
public class AssessCollectionObjectDetail extends Generic {
    /**
     * id
     */
    @PK(PKStrategy.AUTO)
    private Long id;
    /**
     * 采集对象ID
     */
    @Column("collection_obj_id")
    private Long collectionObjId;
    /**
     * 资源类型
     */
    @Column("resource_type")
    private String resourceType;
    /**
     * 资源名称
     */
    @Column("resource_name")
    private String resourceName;
}
