package com.bocloud.cos.entity.internel;

import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.bean.Generic;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @ClassName: BillVmLabel
 * @Description: 针对标签云主机账单统计使用
 * @Author lxy
 * @Date 2021/5/29 15:50
 */
@Data
public class BillVmLabel extends Generic {
    /**
     * 云主机名称
     */
    private String vmName;
    /**
     * 账单id
     */
    private String sn;
    /**
     * 云主机创建时间
     */
    @Column("gmt_create")
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;
    /**
     * 云主机类型
     */
    private String type;
    /**
     * 金额
     */
    private BigDecimal money;
    /**
     * 标签
     */
    @Column("label_value")
    private String labelValue;
}
