package com.bocloud.cos.enums;

import lombok.Getter;
import lombok.Setter;

/**
 * 考核记录状态枚举
 *
 * @author lym
 */
@Getter
public enum AssessRecordStatusEnum {

    // 任务考核状态，分为以下5种
    RECEIVE_ASSESS("接收考核中", "RECEIVE_ASSESS"), SUBMISSION("提交材料中", "SUBMISSION"),
    ASSESSING("考核评分中", "ASSESSING"), FINISHED("考核已完成", "FINISHED");

    @Setter
    private final String name;

    @Setter
    private final String code;

    AssessRecordStatusEnum(String name, String code) {
        this.name = name;
        this.code = code;
    }

    public static String getName(String code) {
        for (AssessRecordStatusEnum c : AssessRecordStatusEnum.values()) {
            if (c.getCode().equals(code)) {
                return c.name;
            }
        }
        return null;
    }
}
