package com.bocloud.cos.enums;

import lombok.Getter;
import lombok.Setter;

/**
 * 考核任务状态枚举
 *
 * @author lym
 */
@Getter
public enum AssessTaskStatusEnum {

    // 任务考核状态，分为以下4种
    CREATEING("创建中", "CREATEING"), WAIT_PUBLISH("待发布", "WAIT_PUBLISH"),
    ASSESSING("考核中", "ASSESSING"), FINISHED("已完成", "FINISHED");

    @Setter
    private final String name;

    @Setter
    private final String code;

    AssessTaskStatusEnum(String name, String code) {
        this.name = name;
        this.code = code;
    }

    public static String getName(String code) {
        for (AssessTaskStatusEnum c : AssessTaskStatusEnum.values()) {
            if (c.getCode().equals(code)) {
                return c.name;
            }
        }
        return null;
    }
}
