package com.bocloud.cos.enums;

import lombok.Getter;
import lombok.Setter;

/**
 * 规则分值设定方式枚举
 *
 * @author lym
 */
@Getter
public enum ScoreTypeEnum {

    // 规则分值设定方式
    SUBMIT_MATERIAL_SATISFACTION_ITEMS("提交材料满足项", 1),
    QUANTITY_INTERVAL("数量区间", 2),
    REPORT_SUBMISSION_STATUS("报告提交情况", 3);

    @Setter
    private final String name;

    @Setter
    private final Integer code;

    ScoreTypeEnum(String name, Integer code) {
        this.name = name;
        this.code = code;
    }

    public static String getName(Integer code) {
        for (ScoreTypeEnum c : ScoreTypeEnum.values()) {
            if (c.getCode().equals(code)) {
                return c.name;
            }
        }
        return null;
    }
}
