package com.bocloud.cos.model;


import com.alibaba.fastjson.JSONObject;
import com.megatron.common.model.GeneralResult;
import lombok.Data;
import org.springframework.stereotype.Component;

@Data
@Component
public class Butler {
    private String username;
    private String password;
    private String accessKey;
    private String secretKey;
    private String regions;
    private String tenant;
    private String url;
    private String uuid;
    private String name;
    private String category;
    private String domainName;
    private String projectName;
    private String projectId;
    private String version;
    private String regionId;
    private Boolean isPublic;
    private String subscriptionId;
    private String clientId;
    private String token;
    private Integer gatewayPort;
    private String gatewayUsername;
    private String gatewayPassword;
    private String proxyHost;
    private Integer proxyPort;
    private String enrollmentNumber;
    private String proxyUri;
    private String domainId;

    public Butler() {
    }

    public Butler(String category) {
        this.category = category;
    }

    public Butler(String name, String uuid, String username, String password, String accessKey, String secretKey, String regions, String tenant, String url, String category, String domainName, String projectName, String version, String regionId) {
        this.name = name;
        this.uuid = uuid;
        this.username = username;
        this.password = password;
        this.accessKey = accessKey;
        this.secretKey = secretKey;
        this.regions = regions;
        this.tenant = tenant;
        this.url = url;
        this.category = category;
        this.domainName = domainName;
        this.projectName = projectName;
        this.version = version;
        this.regionId = regionId;
    }

    public static GeneralResult<Butler> convert(String config) {
        try {
            Butler butler = JSONObject.parseObject(config, Butler.class);
            return new GeneralResult(true, butler, "success");
        } catch (Exception var2) {
            return new GeneralResult(false, var2.getMessage());
        }
    }

    @Override
    public String toString() {
        return JSONObject.toJSONString(this);
    }

}
