package com.bocloud.cos.model;

import com.bocloud.cos.entity.CloudService;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.IgnoreAll;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 封装服务目录树视图
 *
 * @author lym
 * @since 2022年5月30日
 */
@Data
public class ServiceCatalogTreeVO {

    private Long id;

    private String catalogName;

    private Integer sort;

    private List<ServiceCatalogTreeVO> children = new ArrayList<>();

    private String name;
    private String remark;
    private Long parentId;
    private Long creatorId;

    private Long menderId;

    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;

    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtModify;

    /**
     * SN
     */
    private String sn;
    /**
     * 编码
     */
    private String code;
    /**
     * 是否有产品
     */
    private Boolean hasCategory;
    /**
     * 计费项
     */
    private String props;
    /**
     * 当前目录下的服务
     */
    @IgnoreAll
    @Deprecated
    private List<CloudService> cloudServices;

}
