package com.bocloud.cos.repository;

import com.bocloud.cos.entity.MetaQuota;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.common.utils.Common;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.JdbcGenericDao;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Repository
public class MetaQuotaRepository extends JdbcGenericDao<MetaQuota, Long> {

    public MetaQuotaRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate namedParameterJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, namedParameterJdbcTemplate, service);
    }

    public List<MetaQuota> list(Pager pager) {
        String sql = "select a.* from meta_quota a where a.is_deleted = 0 ";
        Map<String, Object> paramMap = getQueryBuilder().getParam(pager.getParams());
        sql = getQueryBuilder().buildRaw(sql, pager, "a");
        return this.list(MetaQuota.class, sql, paramMap);
    }

    public int count(List<Param> params) {
        String sql = "select count(1) from meta_quota a where a.is_deleted = 0 ";
        Map<String, Object> paramMap = getQueryBuilder().getParam(params);
        sql = getQueryBuilder().buildRaw(sql, params, null, "a");
        return this.countQuery(sql, paramMap).intValue();
    }

    public MetaQuota query(Long id) {
        String sql = "select a.* from meta_quota a where a.is_deleted = 0 and a.id = :id";
        Map<String, Object> params = MapTools.simpleMap(Common.ID, id);
        List<MetaQuota> list = this.list(MetaQuota.class, sql, params);
        return list.isEmpty() ? null : list.getFirst();
    }

}
