package com.bocloud.cos.repository.assess;

import com.bocloud.cos.entity.assess.AssessClassify;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * @author wpj
 * @since 2023/10/30
 */
@Repository
public class AssessClassifyRepository extends BasicGenericDao<AssessClassify, Long> {

    public AssessClassifyRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate namedParameterJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, namedParameterJdbcTemplate, service);
    }

    public List<AssessClassify> list(int page, int rows, Map<String, String> sorter, List<Param> params) {
        String sql = "select a.*, u.name as creator from assess_classify a left join cmp.users u on a.creator_id = u.id where 1=1 ";
        sql = getQueryBuilder().buildRaw(sql, new Pager(page, rows, params, sorter), "a");
        Map<String, Object> paramMap = getQueryBuilder().getParam(params);
        return this.list(AssessClassify.class, sql, paramMap);
    }

    public int count(List<Param> params) {
        String sql = "select count(1) from assess_classify a where 1=1 ";
        sql = getQueryBuilder().build(sql, params, null, "a");
        Map<String, Object> paramMap = getQueryBuilder().getParam(params);
        return this.countQuery(sql, paramMap).intValue();
    }

    public void deleteById(Long id) {
        String sql = "delete from assess_classify where id = " + id;
        execute(sql);
    }
}
