package com.bocloud.cos.repository.assess;

import com.bocloud.cos.entity.assess.AssessCollectionObjectDetail;
import com.megatron.common.exception.DataBaseException;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 考核采集对象明细DAO
 *
 * @author lym
 */
@Repository
public class AssessCollectionObjectDetailRepository extends BasicGenericDao<AssessCollectionObjectDetail, Long> {

    public AssessCollectionObjectDetailRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate namedParameterJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, namedParameterJdbcTemplate, service);
    }

    public void deleteByCollectionObjId(Long objId) {
        String sql = "delete from assess_collection_object_detail where collection_obj_id = " + objId;
        execute(sql);
    }

    public void deleteByIds(List<Long> ids) {
        String sql = "delete from assess_collection_object_detail where id in (:ids) ";
        Map<String, Object> paramMap = MapTools.simpleMap("ids", ids);
        execute(sql, paramMap);
    }

    public List<AssessCollectionObjectDetail> listByObjId(Long objId) throws DataBaseException {
        String sql = "select * from assess_collection_object_detail where collection_obj_id = " + objId;
        return list(AssessCollectionObjectDetail.class, sql);
    }
}
