package com.bocloud.cos.repository.assess;

import com.bocloud.cos.entity.assess.AssessCollectionObject;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 考核采集对象DAO
 *
 * @author lym
 */
@Repository
public class AssessCollectionObjectRepository extends BasicGenericDao<AssessCollectionObject, Long> {

    public AssessCollectionObjectRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate namedParameterJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, namedParameterJdbcTemplate, service);
    }

    public List<AssessCollectionObject> list(int page, int rows, Map<String, String> sorter, List<Param> params) {
        String sql = "select a.*, (select count(*) from assess_collection_object_detail where collection_obj_id = a.id) as resource_num from assess_collection_object a where 1=1 ";
        sql = getQueryBuilder().buildRaw(sql, new Pager(page, rows, params, sorter), "a");
        Map<String, Object> paramMap = getQueryBuilder().getParam(params);
        return this.list(AssessCollectionObject.class, sql, paramMap);
    }

    public int count(List<Param> params) {
        String sql = "select count(1) from assess_collection_object a where 1=1 ";
        sql = getQueryBuilder().build(sql, params, null, "a");
        Map<String, Object> paramMap = getQueryBuilder().getParam(params);
        return this.countQuery(sql, paramMap).intValue();
    }

    public void deleteById(Long id) {
        String sql = "delete from assess_collection_object where id = " + id;
        execute(sql);
    }

}
