package com.bocloud.cos.repository.assess;

import java.util.List;
import java.util.Map;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import com.bocloud.cos.entity.assess.AssessLevel;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.framework.core.CurrentService;

/**
 * 评价等级DAO
 */
@Repository
public class AssessLevelRepository extends BasicGenericDao<AssessLevel, Long> {

	public AssessLevelRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate namedParameterJdbcTemplate,
			CurrentService service) {
		super(jdbcTemplate, namedParameterJdbcTemplate, service);
	}

	public List<AssessLevel> list(int page, int rows, Map<String, String> sorter, List<Param> params) {
		String sql = "select a.* from assess_level a where a.is_deleted = 0";
		sql = getQueryBuilder().buildRaw(sql, new Pager(page, rows, params, sorter), "a");
		Map<String, Object> paramMap = getQueryBuilder().getParam(params);
		return this.list(AssessLevel.class, sql, paramMap);
	}

	public int count(List<Param> params) {
		String sql = "select count(1) from assess_level a where a.is_deleted = 0";
		sql = getQueryBuilder().build(sql, params, null, "a");
		Map<String, Object> paramMap = getQueryBuilder().getParam(params);
		return this.countQuery(sql, paramMap).intValue();
	}

	public AssessLevel query(Long id) {
		String sql = "select * from assess_level a where a.is_deleted = 0 and id = :id";
		Map<String, Object> params = MapTools.simpleMap("id", id);
		List<AssessLevel> list = this.list(AssessLevel.class, sql, params);
		return list.isEmpty() ? null : list.get(0);
	}

}
