package com.bocloud.cos.repository.assess;

import com.bocloud.cos.entity.assess.AssessObject;
import com.megatron.common.model.Pager;
import com.megatron.database.core.intf.impl.BasicGenericDao;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * 考核对象DAO
 *
 * @author lym
 */
@Repository
public class AssessObjectRepository extends BasicGenericDao<AssessObject, Long> {

    public AssessObjectRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate namedParameterJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, namedParameterJdbcTemplate, service);
    }

    public List<AssessObject> list(int page, int rows, Map<String, String> sorter, Long taskId) {
        String sql = "select a.* from assess_object a where a.task_id = " + taskId;
        sql = getQueryBuilder().buildRaw(sql, new Pager(page, rows, null, sorter), "a");
        Map<String, Object> paramMap = getQueryBuilder().getParam(null);
        return list(AssessObject.class, sql, paramMap);
    }

    public int count(Long taskId) {
        String sql = "select count(1) from assess_object a where a.task_id = " + taskId;
        sql = getQueryBuilder().build(sql, null, null, "a");
        return countQuery(sql, null).intValue();
    }

    public void deleteByTaskId(Long taskId) {
        String sql = "delete from assess_object where task_id = " + taskId;
        execute(sql);
    }

    public void deleteById(Long id) {
        String sql = "delete from assess_object where id = " + id;
        execute(sql);
    }

    public List<AssessObject> queryByTaskId(Long taskId) {
        String sql = "select * from assess_object where task_id = " + taskId;
        return list(AssessObject.class, sql);
    }

}
