package com.bocloud.cos.intf;

import com.bocloud.cos.entity.Promotion;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.common.model.RequestContext;

import java.util.List;
import java.util.Map;


public interface PromotionService {

	/**
	 * 查询列表
	 * 
	 * @param page
	 * @param rows
	 * @param params
	 * @param sorter
	 * @param context
	 * @return
	 */
	GeneralResult list(int page, int rows, List<Param> params, Map<String, String> sorter, RequestContext context);

	/**
	 * 创建
	 * 
	 * @param promotion
	 * @param context
	 * @return
	 */
	GeneralResult create(Promotion promotion, RequestContext context);

	/**
	 * 修改
	 * 
	 * @param promotion
	 * @param context
	 * @return
	 */
	GeneralResult modify(Promotion promotion, RequestContext context);

	/**
	 * 查询详情
	 * 
	 * @param id
	 * @return
	 */
	GeneralResult detail(Long id, RequestContext context);

	/**
	 * 删除
	 * 
	 * @param id
	 * @param context
	 * @return
	 */
	GeneralResult remove(Long id, RequestContext context);

	/**
	 * 分配
	 * 
	 * @param id
	 * @param tenantId
	 * @param count
	 * @param context
	 * @return
	 */
	GeneralResult allocation(Long id, Long tenantId, Integer count, RequestContext context);
	

	/**
	 * 查询活动下的租户分配情况
	 * 
	 * @param pager
	 * @param id
	 * @param context
	 * @return
	 */
	GeneralResult promotionTenants(Pager pager, Long id, RequestContext context);

	/**
	 * 查询租户下的优惠券
	 *
	 * @param pager
	 * @param context
	 * @return
	 */
	GeneralResult coupon(Pager pager, RequestContext context);

}
