package com.bocloud.cos.intf;

import com.bocloud.cos.model.ApplicationParam;
import com.bocloud.cos.model.RosApplicationParam;
import com.bocloud.cos.params.CloneParams;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.RequestContext;

/**
 * 服务操作接口
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年4月15日
 */
public interface ResourceApplicationService {

    /**
     * 服务申请
     *
     * @param params  订购参数
     * @param context 当前用户
     * @return 预付费时返回订单号
     */
    GeneralResult<String> process(ApplicationParam params, RequestContext context);

    /**
     * 服务申请(资源编排)
     *
     * @param rosApplicationParam 资源编排订购参数
     * @return 订购参数
     */
    GeneralResult<RosApplicationParam> process(RosApplicationParam rosApplicationParam);

    /**
     * 资源编排回调
     *
     * @param success 是否成功
     * @param orderId 订单ID
     * @param message 消息
     */
    void rosCallBack(boolean success, long orderId, String message);

    /**
     * 克隆云主机
     *
     * @param configs 参数
     * @param context 当前用户
     */
    void clone(CloneParams configs, RequestContext context);

}
