package com.bocloud.cos.intf;

import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;
import com.bocloud.cos.entity.SkuSpec;

import java.util.List;

/**
 * SKU规格业务操作接口
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年3月10日
 */
public interface SkuSpecService {

    /**
     * 查询规格列表
     *
     * @param pager
     * @return
     */
    GeneralResult<GridBean<SkuSpec>> list(Pager pager);

    /**
     * 查询规格详情
     *
     * @param id
     * @return
     */
    GeneralResult<SkuSpec> detail(Long id);

    /**
     * @param code
     * @param categoryId
     * @return
     */
    GeneralResult listSpecs(String code, Long categoryId);

    /**
     * 根据code查询spec
     *
     * @param serverId
     * @param code
     * @param type
     * @param context
     * @return
     */
    GeneralResult<List<SkuSpec>> listSpecsByCode(Long serverId, String code, String type, RequestContext context);
}
