package com.bocloud.cos.provider.aliyun;

import com.aliyun.bssopenapi20171214.models.QueryBillResponseBody;
import com.megatron.common.utils.DateTools;
import com.bocloud.cos.model.PublicCloudBillModel;
import org.apache.commons.lang3.StringUtils;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class BillingConvertor {

    public List<PublicCloudBillModel> convertList(List<? extends QueryBillResponseBody.QueryBillResponseBodyDataItemsItem> objects) {
        List<PublicCloudBillModel> vpcModels = new ArrayList();
        Iterator var3 = objects.iterator();

        while(var3.hasNext()) {
            QueryBillResponseBody.QueryBillResponseBodyDataItemsItem object = (QueryBillResponseBody.QueryBillResponseBodyDataItemsItem)var3.next();
            vpcModels.add(this.convertModel(object));
        }

        return vpcModels;
    }

    public PublicCloudBillModel convertModel(QueryBillResponseBody.QueryBillResponseBodyDataItemsItem item) {
        PublicCloudBillModel model = null;
        if (null != item) {
            model = new PublicCloudBillModel();
            model.setOrderSn(item.getRecordID());
            model.setStatus(item.getStatus());
            model.setProductCode(item.getProductCode());
            model.setProductName(item.getProductName());
            model.setProductDetail(item.getProductDetail());
            String usageStartTime = item.getUsageStartTime();
            if (!StringUtils.isEmpty(usageStartTime)) {
                model.setFeeBeginTime(DateTools.stringToDateTime(usageStartTime));
            }

            String usageEndTime = item.getUsageEndTime();
            if (!StringUtils.isEmpty(usageEndTime)) {
                model.setFeeEndTime(DateTools.stringToDateTime(usageEndTime));
            }

            Float pretaxGrossAmount = item.getPretaxGrossAmount() == null ? 0.0F : item.getPretaxGrossAmount();
            model.setPretaxGrossAmount((new BigDecimal((double)pretaxGrossAmount)).setScale(2, 4));
            Float invoiceDiscount = item.getInvoiceDiscount() == null ? 0.0F : item.getInvoiceDiscount();
            model.setInvoiceDiscount((new BigDecimal((double)invoiceDiscount)).setScale(2, 4));
            String roundDownDiscount = item.getRoundDownDiscount() == null ? "0" : item.getRoundDownDiscount();
            model.setRoundDownDiscount((new BigDecimal(roundDownDiscount)).setScale(2, 4));
            Float pretaxAmount = item.getPretaxAmount() == null ? 0.0F : item.getPretaxAmount();
            model.setPretaxAmount((new BigDecimal((double)pretaxAmount)).setScale(2, 4));
            Float paymentAmount = item.getPaymentAmount() == null ? 0.0F : item.getPaymentAmount();
            model.setMoney((new BigDecimal((double)paymentAmount)).setScale(2, 4));
            Float deductedByCoupons = item.getDeductedByCoupons() == null ? 0.0F : item.getDeductedByCoupons();
            model.setDeductedByCoupons((new BigDecimal((double)deductedByCoupons)).setScale(2, 4));
            Float deductedByPrepaidCard = item.getDeductedByPrepaidCard() == null ? 0.0F : item.getDeductedByPrepaidCard();
            model.setDeductedByPrepaidCard((new BigDecimal((double)deductedByPrepaidCard)).setScale(2, 4));
        }

        return model;
    }
}
