package com.bocloud.cos.provider.aliyun;

import com.aliyun.credentials.utils.StringUtils;
import com.aliyun.ecs20140526.models.DescribeRegionsResponseBody;
import com.bocloud.cos.model.RegionModel;
import com.bocloud.cos.provider.convertor.BeanConvertor;

import java.util.*;

public class RegionConvertor implements BeanConvertor<RegionModel, DescribeRegionsResponseBody.DescribeRegionsResponseBodyRegionsRegion> {
    private static Map<String, String> regionName = new HashMap();

    public RegionConvertor() {
    }

    @Override
    public List<RegionModel> convertList(List<? extends DescribeRegionsResponseBody.DescribeRegionsResponseBodyRegionsRegion> objects) {
        List<RegionModel> models = new ArrayList();
        Iterator var3 = objects.iterator();

        while (var3.hasNext()) {
            DescribeRegionsResponseBody.DescribeRegionsResponseBodyRegionsRegion object = (DescribeRegionsResponseBody.DescribeRegionsResponseBodyRegionsRegion) var3.next();
            models.add(this.convertModel(object));
        }

        return models;
    }

    @Override
    public RegionModel convertModel(DescribeRegionsResponseBody.DescribeRegionsResponseBodyRegionsRegion object) {
        RegionModel model = null;
        if (null != object) {
            model = new RegionModel();
            String regionCode = object.getRegionId();
            model.setCode(regionCode);
            String localName = object.getLocalName();
            if (regionName.containsKey(regionCode) && !localName.contains(regionName.get(regionCode))) {
                localName = String.format("%s (%s)", localName, regionName.get(regionCode));
            }

            if (StringUtils.isEmpty(localName)) {
                localName = regionCode;
            }

            model.setName(localName);
            model.setRegionId(regionCode);
        }

        return model;
    }

    static {
        regionName.put("cn-qingdao", "青岛");
        regionName.put("cn-beijing", "北京");
        regionName.put("cn-zhangjiakou", "张家口");
        regionName.put("cn-huhehaote", "呼和浩特");
        regionName.put("cn-hangzhou", "杭州");
        regionName.put("cn-shanghai", "上海");
        regionName.put("cn-shenzhen", "深圳");
    }
}