package com.bocloud.cos.provider.aws;

import com.bocloud.cos.model.ObjectStorageContainerModel;
import com.bocloud.cos.provider.convertor.BeanConvertor;
import software.amazon.awssdk.services.s3.model.Bucket;

import java.util.ArrayList;
import java.util.List;

public class OssConvertor implements BeanConvertor<ObjectStorageContainerModel, Bucket> {
    @Override
    public List<ObjectStorageContainerModel> convertList(List<? extends Bucket> buckets) {
        List<ObjectStorageContainerModel> ossModels = new ArrayList<>();
        for (Bucket bucket : buckets) {
            ossModels.add(convertModel(bucket));
        }
        return ossModels;
    }

    @Override
    public ObjectStorageContainerModel convertModel(Bucket bucket) {
        ObjectStorageContainerModel model = new ObjectStorageContainerModel();
        model.setName(bucket.name());
        return model;
    }
}
