package com.bocloud.cos.provider.azure;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cos.model.BillPeriodModel;
import com.bocloud.cos.provider.convertor.BeanJsonConvertor;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Optional;

public class BillPeriodConvertor implements BeanJsonConvertor<BillPeriodModel> {

    public BillPeriodConvertor() {
    }

    @Override
    public BillPeriodModel convertModel(JSONObject object) {
        BillPeriodModel model = new BillPeriodModel();
        model.setUuid(object.getString("id"));
        model.setName(object.getString("name"));
        model.setType(object.getString("type"));
        Optional.ofNullable(object.getJSONObject("properties")).ifPresent((properties) -> {
            Optional.ofNullable(properties.getString("billingPeriodStartDate")).map(this::getData).ifPresent(model::setStartDate);
            Optional.ofNullable(properties.getString("billingPeriodEndDate")).map(this::getData).ifPresent(model::setEndDate);
        });
        return model;
    }

    private Date getData(String time) {
        try {
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
            Date date = simpleDateFormat.parse(time);
            return date;
        } catch (Exception var4) {
            return new Date();
        }
    }
}
