package com.bocloud.cos.provider.tencent;

import com.megatron.common.utils.DateTools;
import com.bocloud.cos.model.PublicCloudBillModel;
import com.bocloud.cos.provider.convertor.BeanConvertor;
import com.tencentcloudapi.billing.v20180709.models.BillResourceSummary;
import org.apache.commons.lang3.StringUtils;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class BillingConvertor implements BeanConvertor<PublicCloudBillModel, BillResourceSummary> {
    public BillingConvertor() {
    }

    @Override
    public List<PublicCloudBillModel> convertList(List<? extends BillResourceSummary> objects) {
        List<PublicCloudBillModel> vpcModels = new ArrayList();
        Iterator var3 = objects.iterator();

        while (var3.hasNext()) {
            BillResourceSummary object = (BillResourceSummary) var3.next();
            vpcModels.add(this.convertModel(object));
        }

        return vpcModels;
    }

    @Override
    public PublicCloudBillModel convertModel(BillResourceSummary item) {
        PublicCloudBillModel model = null;
        if (null != item) {
            model = new PublicCloudBillModel();
            model.setOrderSn(item.getResourceId());
            model.setMoney(new BigDecimal(item.getRealTotalCost()));
            model.setProductDetail(item.getProductCodeName());
            model.setProductName(item.getBusinessCodeName());
            model.setRegionName(item.getRegionName());
            model.setZoneName(item.getZoneName());
            model.setResourceId(item.getResourceId());
            String usageStartTime = item.getFeeBeginTime();
            if (!StringUtils.isEmpty(usageStartTime)) {
                model.setFeeBeginTime(DateTools.stringToDateTime(usageStartTime));
            }

            String usageEndTime = item.getFeeEndTime();
            if (!StringUtils.isEmpty(usageEndTime)) {
                model.setFeeEndTime(DateTools.stringToDateTime(usageEndTime));
            }
        }

        return model;
    }
}
